精华内容
参与话题
问答
  • 先说这个方式的一个弊端,那就是服务器端这边代码不能与svn服务器出现冲突,一旦冲突就失效。 实现原理是,利用svn版本库,hooks目录的bat钩子开展工作。 共在hooks目录下建立3个文件如下:post-commit.bat 作用是...

    先说这个方式的一个弊端,那就是服务器端这边代码不能与svn服务器出现冲突,一旦冲突就失效。

    实现原理是,利用svn版本库,hooks目录的bat钩子开展工作。

    共在hooks目录下建立3个文件如下:
    post-commit.bat 作用是:钩子入口!
    postcommit.log 作用是:记录最后一次执行的结果(可以记录最后一次报错)建立一个空文件就好!
    post-commit-run.bat 作用是:自动更新的核心部分!

    post-commit.bat的代码是:

    call %~dp0post-commit-run.bat %* > %~dp0postcommit.log 2>&1

    post-commit-run.bat的代码是:

    @echo off

    SET REPOS=%1
    SET REV=%2

    SET DIR=%REPOS%/hooks
    SET PATH=%PATH%;

    SET WORKING_COPY=D:/Websites/www
    svn update %WORKING_COPY% --username your_name --password your_pwd

    注意填写客户端地址、用户名和密码,这里的是:D:/Websites/www、admin和123456. 

     hooks目录地址:配置密码那边,如图

     

     

    另外一个别人的博客,大同小异,只是比较简单,没有做日志而已

    在Windows 03 Server上搭建了 VisualSVN 服务器,想要设置成当提交到SVN中的任何修改都同步更新到本机服务器上的WEB目录下。

    根据网上各种版本的参考,基本上上使用svn自带的hook功能实现:

    在SVN 项目版本的存储目录的hooks 目录中,建立一个post-commit.bat 文件:

    @echo off

    SET REPOS=%1
    SET REV=%2

    SET DIR=%REPOS%/hooks
    SET PATH=%PATH%;

    SET WORKING_COPY=D:/Websites/www
    svn update %WORKING_COPY% --username your_name --password your_pwd

    注意事项:

    1.需要将SVN服务器的bin目录加入到path路径中,加入后,未重启,在命令行下path值立即生效,但是SVN服务器却无法找到,总是提示:

    警告: post-commit hook failed (exit code 1) with output:
    'svn' 不是内部或外部命令,也不是可运行的程序或批处理文件。

    2.需要设置SVN服务对文件桌面系统权限,否则会报无法读写文件的错:

    选择本地系统账户,并勾选 允许服务与桌面交互

    image

    OVER

    ORG: http://blog.donews.com/me1105/archive/2010/12/05/82.aspx

     

    转载于:https://www.cnblogs.com/hfdp/p/5550561.html

    展开全文
  • SVN钩子

    千次阅读 2019-02-21 10:42:21
    先说说钩子是干什么的吧,,简单的说,svn钩子就是在提交svn时前后所要触发的事件,于是我们可以用钩子做一些提交时的限制,及提交后的操作。最常用的一般有两个,pre-commit,post-commit。下面分别简单说下概念。 ...

    先说说钩子是干什么的吧,,简单的说,svn钩子就是在提交svn时前后所要触发的事件,于是我们可以用钩子做一些提交时的限制,及提交后的操作。最常用的一般有两个,pre-commit,post-commit。下面分别简单说下概念。

    一、钩子概述

    1)start-commit — 开始提交的通知

    描述
    start-commit 在开始事务之前执行。通常用来确定用户是否有提交权限。
    如果 start-commit 钩子程序返回非零值,提交就会在创建事务之前停止,stderr 的任何输出都会返回到客户端。

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.认证过的尝试提交的用户名
    3.Colon-separated list of capabilities that a client passes to the server, including depth, mergeinfo, and log-revprops


    2)pre-commit — 在提交结束之前提醒。

    描述
    pre-commit 钩子在事务创建新版本之前运行。通常这个钩子是用来保护因为内容或位置(例如,你要求所有到一个特定分支的提交必须包括一个 bug 追踪的 ticket 号,或者是要求日志信息不为空)而不允许的提交。
    如果 pre-commit 钩子返回非零值,提交会终止,提交事务被删除,所有 stderr 的输出会返回到客户端。 

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.提交事务的名称

     

    3)post-commit — 成功提交的通知。

    描述
    post-commit 钩子在事务完成,创建新版本后执行。大多数人用这个钩子来发送关于提交的描述性电子邮件,或者用来提醒其它工具(例如问题跟踪),发生了提交动作。一些配置也使用这个钩子触发版本库的备份进程。

    如果 post-commit 钩子返回非零值,提交不会终止,因为它已经完成。然后,所有 stderr 的输出都会返回到客户端,让诊断钩子的失败更容易。

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.提交创建的修订版本号

     

    二、pre-commit钩子举例说明

    1、此脚本会在提交前对事件进行检查

    [root@CentOS_11 test]# cat /svndata/test/hooks/pre-commit 
    #!/bin/sh

    REPOS="$1"
    TXN="$2"
    export LANG=en_US.UTF-8                                                           ; export LC_CTYPE=en_US.UTF-8 #设置本地字符集编码
    MAX_SIZE=5242880000
    FILTER='\.()$'
    SVNLOOK=/usr/bin/svnlook
    AUTHORS='(tao|wang)'

    LOGMSG=`$SVNLOOK log -t "$TXN" "$REPOS" |wc -c`                     ;  判断输入log的最小字符,小于10个不让提交
    if [ $LOGMSG -lt 10 ];then
    echo -e "log message can't be empty or less 9 chars as commit!" >&2
    exit 1
    fi
    SVNUSER=`$SVNLOOK author -t "$TXN" "$REPOS"`                        ;  限制提交用户,不是脚本定义的用户不让提交,不过基本svn权限配置文件就够了。
    if echo $SVNUSER |/bin/grep -vEq $AUTHORS ;then
    echo -e "Sorry you no be author" >&2
    exit 1
    fi

    #定义过滤出当前提交的所以文件内容

    File=$($SVNLOOK changed -t $TXN $REPOS|cut -d " " -f 4-)            ;  限制提交文件的类型

     

    #对当前提交的所有文件进行循环

    echo "$File" |while read f;do

    #如果文件被过滤出来就则匹配,输出不允许提交。

    if echo $f |tr A-Z a-z|grep -Eq $FILTER;then

    echo "File $f is not allow $FILTER file" >&2
    exit 1
    fi
    FilesSize=`$SVNLOOK cat -t "$TXN" "$REPOS" "$f" |wc -c`              ; 限制单个文件提交的大小
    if [ "$FilesSize" -gt "$MAX_SIZE" ];then
    echo "File $f is too large(must <=$MAX_SIZE)B" >&2
    exit 1
    fi
    done

    ======================

    提示:将以上脚本放到版本库的hooks下,并给执行权限,将提交时如果有符合以上限制,将限制提交。这里就不作测试,可自行测试,很简单。

    展开全文
  • svn钩子

    千次阅读 2018-03-17 04:06:37
    先说说钩子是干什么的吧,,简单的说,svn钩子就是在提交svn时前后所要触发的事件,于是我们可以用钩子做一些提交时的限制,及提交后的操作。最常用的一般有两个,pre-commit,post-commit。下面分别简单说下概念。一...

    先说说钩子是干什么的吧,,简单的说,svn钩子就是在提交svn时前后所要触发的事件,于是我们可以用钩子做一些提交时的限制,及提交后的操作。最常用的一般有两个,pre-commit,post-commit。下面分别简单说下概念。

    一、钩子概述

    1)start-commit — 开始提交的通知

    描述
    start-commit 在开始事务之前执行。通常用来确定用户是否有提交权限。
    如果 start-commit 钩子程序返回非零值,提交就会在创建事务之前停止,stderr 的任何输出都会返回到客户端。

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.认证过的尝试提交的用户名
    3.Colon-separated list of capabilities that a client passes to the server, including depth, mergeinfo, and log-revprops


    2)pre-commit — 在提交结束之前提醒。

    描述
    pre-commit 钩子在事务创建新版本之前运行。通常这个钩子是用来保护因为内容或位置(例如,你要求所有到一个特定分支的提交必须包括一个 bug 追踪的 ticket 号,或者是要求日志信息不为空)而不允许的提交。
    如果 pre-commit 钩子返回非零值,提交会终止,提交事务被删除,所有 stderr 的输出会返回到客户端。 

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.提交事务的名称

     

    3)post-commit — 成功提交的通知。

    描述
    post-commit 钩子在事务完成,创建新版本后执行。大多数人用这个钩子来发送关于提交的描述性电子邮件,或者用来提醒其它工具(例如问题跟踪),发生了提交动作。一些配置也使用这个钩子触发版本库的备份进程。

    如果 post-commit 钩子返回非零值,提交不会终止,因为它已经完成。然后,所有 stderr 的输出都会返回到客户端,让诊断钩子的失败更容易。

    输入参数
    传递给你钩子程序的命令行参数,按照顺序是:

    1.版本库路径
    2.提交创建的修订版本号

     

    二、pre-commit钩子举例说明

    1、此脚本会在提交前对事件进行检查

    [root@CentOS_11 test]# cat /svndata/test/hooks/pre-commit 
    #!/bin/sh

    REPOS="$1"
    TXN="$2"
    export LANG=en_US.UTF-8                                                           ; export LC_CTYPE=en_US.UTF-8 #设置本地字符集编码
    MAX_SIZE=5242880000
    FILTER='\.()$'
    SVNLOOK=/usr/bin/svnlook
    AUTHORS='(tao|wang)'

    LOGMSG=`$SVNLOOK log -t "$TXN" "$REPOS" |wc -c`                     ;  判断输入log的最小字符,小于10个不让提交
    if [ $LOGMSG -lt 10 ];then
    echo -e "log message can't be empty or less 9 chars as commit!" >&2
    exit 1
    fi
    SVNUSER=`$SVNLOOK author -t "$TXN" "$REPOS"`                        ;  限制提交用户,不是脚本定义的用户不让提交,不过基本svn权限配置文件就够了。
    if echo $SVNUSER |/bin/grep -vEq $AUTHORS ;then
    echo -e "Sorry you no be author" >&2
    exit 1
    fi

    #定义过滤出当前提交的所以文件内容

    File=$($SVNLOOK changed -t $TXN $REPOS|cut -d " " -f 4-)            ;  限制提交文件的类型

     

    #对当前提交的所有文件进行循环

    echo "$File" |while read f;do

    #如果文件被过滤出来就则匹配,输出不允许提交。

    if echo $f |tr A-Z a-z|grep -Eq $FILTER;then

    echo "File $f is not allow $FILTER file" >&2
    exit 1
    fi
    FilesSize=`$SVNLOOK cat -t "$TXN" "$REPOS" "$f" |wc -c`              ; 限制单个文件提交的大小
    if [ "$FilesSize" -gt "$MAX_SIZE" ];then
    echo "File $f is too large(must <=$MAX_SIZE)B" >&2
    exit 1
    fi
    done

    ======================

    提示:将以上脚本放到版本库的hooks下,并给执行权限,将提交时如果有符合以上限制,将限制提交。这里就不作测试,可自行测试,很简单。

    ======================

     

    二、post-commit钩子举例说明

    post-commit是在提交后进行的操作事件,用这个我们可以实现两个SVN服务器的时时同步,保持版本库的最新,或一些其他的方案,这里我只提供时时同步脚本。

    环境:两台SVN服务器,版本库全部相同。并且两台配置SSH无密钥登陆。

    说明:这里只在一台SVN上操作,另一台操作完全一样。

    脚本原理:

    1)先通过ssh远程执行无端SVN服务器中svn版本库的版本号和当前SVN服务器SVN版本库的版本号做对比。

    2)对比完后,当前的SVN版本库最新大于远端SVN版本号,并通过svnadmin做增量备份。

    3)备份完再通过ssh传到远端SVN服务器上,将增量备份进行还原操作

    下面的脚本只是简单的实现,并未做完善,大家可以自己写更好的脚本实现,这里只是说明一个思路而已。

    [root@CentOS_11 test]# cat /svndata/test/hooks/post-commit
    #!/bin/sh
    REPOS="$1"
    REV="$2"
    SVNLOOK=/usr/bin/svnlook
    R_ID=`/usr/bin/ssh root@192.168.1.12 "$SVNLOOK youngest /svndata/test/"`
    L_ID=`$SVNLOOK youngest $REPOS`
    [ "$R_ID" -eq "$L_ID" ] && {
    echo "The ID is neweast!!" >>/root/a.log
    }
    [ "$R_ID" -gt "$L_ID" ] && {
    echo "Warning The R_ID is Biger than L_ID" >>/root/a.log
    }
    [ "$R_ID" -lt "$L_ID" ] && {

    R_ID_1=$((${R_ID}+1))
    sleep 1
    /usr/bin/svnadmin dump --incremental -r ${R_ID_1}:${L_ID} /svndata/test >/root/svn_inter_bak/test_${R_ID_1}:${L_ID}
    [ $? -ne 0 ] && {
    echo "bakcup test dump failed" >>/root/a.log
    }||{
    echo "test dump is OK" >>$LOGS/a.log
    sleep 1
    }
    /usr/bin/scp /root/svn_inter_bak/test_${R_ID_1}:${L_ID} root@192.168.1.12:/root/svn_inter_dir/
    [ $? -eq 0 ] && {
    # /usr/bin/ssh root@192.168.1.12 "/bin/sh /root/svn_inter_restore.sh"
    ssh root@192.168.1.12 "/usr/bin/svnadmin load /svndata/test < /root/svn_inter_dir/*"
    ssh root@192.168.1.12 "/bin/rm -f /root/svn_inter_dir/*"
    }||{
    echo "warning..scp remote is failed" >>/root/a.log
    }
    }

    展开全文
  • svn 钩子

    2019-08-05 01:43:37
    1.安装宝塔 一键安装 yum install -y wget && wget -O install.sh http://download.bt.cn/install/install_6.0.sh && sh install.sh 2.宝塔安装成功,提示 3.进入宝塔安装lnmp环境 ...

    1.安装宝塔

    一键安装

     

    yum install -y wget && wget -O install.sh http://download.bt.cn/install/install_6.0.sh && sh install.sh

     

    2.宝塔安装成功,提示

     

     

     

    3.进入宝塔安装lnmp环境

    编译安装

     

    Php 7.0 ~ 7.3

    MySQL 5.6

    Nginx 1.5

     

    1. 安装svn

    yum install -y subversion

    5.检查安装是否成功 

    svnserve --version

    6.创建svn资源仓库

    [root@localhost ~]# svnadmin create /svndir

    [root@localhost ~]# cd /svndir/

    [root@localhost svndir]# ls

    conf  db  format  hooks  locks  README.txt

    [root@localhost svndir]# cd conf/

    [root@localhost conf]# ls

    authz  passwd  svnserve.conf

    7.新增用户及密码,配置权限

    已经看到在仓库下面生成了三个文件

    authz #权限配置文件

    passwd #用户名密码文件

    svnserve.conf #资源库配置文件

     

    [root@localhost conf]# vim passwd

     

    [users]

    # harry = harryssecret

    # sally = sallyssecret

    yunwei = 123456

     

    新增一行:

    yunwei = 123456

    新增用户“yunwei”,密码是“123456”

    [root@localhost conf]# vim authz

    [groups]

    # harry_and_sally = harry,sally

    # harry_sally_and_joe = harry,sally,&joe

     

    [/]

    * = r

    @admin = rw

    dangerman =

     

    [svndir:/]

    @admin = rw

     

    在[groups]下面加入:

    * = r #所有用户有读权限

    dangerman = ##危险分子?什么是危险分子?没有任何权限

     

    [svndir:/] ###定义目录,项目的根目录

    * = rw

     

    [root@localhost conf]# vim svnserve.conf

     

    这个配置文件打开下面几行前面的注释,删除最前面的空格:

    anon-access = read

    auth-access = write

    password-db = passwd

    authz-db = authz

    1. 配置svn自动化

    Hooks  post-commit 复制

    #!/bin/sh
    
    # POST-COMMIT HOOK
    #
    # The post-commit hook is invoked after a commit.  Subversion runs
    # this hook by invoking a program (script, executable, binary, etc.)
    # named 'post-commit' (for which this file is a template) with the 
    # following ordered arguments:
    #
    #   [1] REPOS-PATH   (the path to this repository)
    #   [2] REV          (the number of the revision just committed)
    #   [3] TXN-NAME     (the name of the transaction that has become REV)
    #
    # Because the commit has already completed and cannot be undone,
    # the exit code of the hook program is ignored.  The hook program
    # can use the 'svnlook' utility to help it examine the
    # newly-committed tree.
    #
    # The default working directory for the invocation is undefined, so
    # the program should set one explicitly if it cares.
    #
    # On a Unix system, the normal procedure is to have 'post-commit'
    # invoke other programs to do the real work, though it may do the
    # work itself too.
    #
    # Note that 'post-commit' must be executable by the user(s) who will
    # invoke it (typically the user httpd runs as), and that user must
    # have filesystem-level permission to access the repository.
    #
    # On a Windows system, you should name the hook program
    # 'post-commit.bat' or 'post-commit.exe',
    # but the basic idea is the same.
    #
    # The hook program runs in an empty environment, unless the server is
    # explicitly configured otherwise.  For example, a common problem is for
    # the PATH environment variable to not be set to its usual value, so
    # that subprograms fail to launch unless invoked via absolute path.
    # If you're having unexpected problems with a hook program, the
    # culprit may be unusual (or missing) environment variables.
    #
    # CAUTION:
    # For security reasons, you MUST always properly quote arguments when
    # you use them, as those arguments could contain whitespace or other
    # problematic characters. Additionally, you should delimit the list
    # of options with "--" before passing the arguments, so malicious
    # clients cannot bootleg unexpected options to the commands your
    # script aims to execute.
    # For similar reasons, you should also add a trailing @ to URLs which
    # are passed to SVN commands accepting URLs with peg revisions.
    #
    # Here is an example hook script, for a Unix /bin/sh interpreter.
    # For more examples and pre-written hooks, see those in
    # the Subversion repository at
    # http://svn.apache.org/repos/asf/subversion/trunk/tools/hook-scripts/ and
    # http://svn.apache.org/repos/asf/subversion/trunk/contrib/hook-scripts/
    
    export LANG=en_US.UTF-8
    REPOS="$1"
    REV="$2"
    TXN_NAME="$3"
    LOG_PATH=/svn/svn_hook.log
    SVN=/usr/bin/svn
    WEB=/www/wwwroot/pay
    chown -R www:www /www/wwwroot/pay
    $SVN update $WEB --username vonly --password vonly~76768181
    #mailer.py commit "$REPOS" "$REV" /path/to/mailer.conf
    

     

    文件目录 跟 svn账号改掉

    1. 到服务器网站根目录下执行

    Svn co checkout svn://127.0.0.1

    1. 在本地执行svn更新 ,之后在svn到linux中
    展开全文
  • SVN 钩子

    2014-10-09 10:40:41
    允许用户修改Subversion日志的钩子脚本 (windows) 我想用过Subversion的人一定有过这样的问题:“为什么不允许用户修改日志?”,因为这种改变不可还原(目前这个操作还没有受到版本控制的管理),所以这项功能默认...
  • SVN钩子.wps

    2012-11-17 10:32:40
    SVN钩子.wps
  • 作者:朱金灿来源:http://blog.csdn.net/clever101 Subversion本身有很好的扩展性,用户可以通过钩子实现一些自定义的功能。...下面简单介绍下: 服务器钩子: 锁定的2种pre-lock钩子在每次有人
  • svn钩子详解

    2019-01-25 11:38:41
    如果start-commit钩子程序返回非零值,提交就会在创建之前停止,标准错误的任何输出都会返回到客户端。 输入参数: 传递给你钩子程序的命令行参数,按照顺序是: a.版本库路径 b.认证过的尝试提交的用户名 作用: ...
  • svn钩子脚本

    2019-09-11 22:25:00
    REP0S="$1" REV="$2" export LANG=en_US.UTF-8 LOGPATH="/app/log" [ !-d ${LOGPATH}] && mkdir $[LOGPATH) -p #update content from svn↓14...SVN=/usr/bin/svnSVN update --username test --password...
  • svn 钩子脚本

    2014-06-23 17:40:55
    #vim post-commit#!/bin/bash REPOS="$1" REV="$2" SVNLOOK="/usr/bin/svnlook" echo"`date+%F`">>/tmp/post.log echo"REPOS=$1REV=$2">>/tmp/post.log echo-e"\$@=$@#">&g...
  • svn 钩子开启

    2017-04-24 17:24:00
    为什么80%的码农都做不了架构师?>>> ...
  • 关于svn钩子

    2016-06-24 10:12:11
    svn钩子钩子脚本就是shell的写法,钩子就是被某些版本库事件触发的程序。常用钩子: post-commit:在提交完成成功创建之后执行该钩子。(提交已经完成,不可更改) 更新之后,通过邮件、微信通知 更新触发checkout...
  • SVN钩子说明

    2016-05-26 11:14:00
    post-commit在提交完成,成功创建版本之后执行该钩子,提交已经完成,不可更改,因此本脚本的返回值被忽略。 post-lock对文件进行加锁操作之后执行该脚本 post-revprop-change在修改 revision 属性之后,执行该...
  • svn钩子 新版

    2015-03-18 16:24:00
    REPOS="$1" REV="$2" ...SVN="/usr/bin/svn" WWWROOT="/d01/www"; svnlook changed -r $REV $REPOS |awk -F ' ' "{ system("$SVN" " up " "$WWWROOT""/"$2); system("/usr/bin/svn up /d01/www"...
  • svn 钩子hooks

    2014-07-02 13:52:07
    1种方式在服务端实现 ... 在客户端来绑定脚本,可以控制到具体的目录、文件,控制的更加细致     http://www.xuebuyuan.com/90159.html http://www.svnchina.com/content_211.html http://www.blogj...
  • svn钩子配置

    2014-01-21 10:45:49
    SVN可以通过钩子功能,在提交的时候同步更新至指定目录   1、进入版本库的hooks目录   cd /home/svn/project1/hooks   2、将post-commit.tmpl 复制为 post-commit   cp post-commit.tmpl post-commit ...

空空如也

1 2 3 4 5 ... 20
收藏数 918
精华内容 367
关键字:

svn钩子